//+------------------------------------------------------------------+
//|                                                     MACD_CCI.mq4 |
//|                                   Copyright  2009, challenger78 |
//+------------------------------------------------------------------+
//mod mtf

#property  copyright "challenger78"

#property  indicator_chart_window
#property  indicator_buffers 4
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_color3  Gray
#property  indicator_color4  Gray
#property  indicator_width1  10
#property  indicator_width2  10
#property  indicator_width3  10
#property  indicator_width4  10

#property  indicator_minimum 0
#property  indicator_maximum 10 // was 77

extern int TimeFrame=0;

extern int macdMAfast   =12;  //144
extern int macdMAslow   =26;  //233;
extern int macdSigMA    =9;   //21
extern int macdPrice    =0;
extern int macdLnMode   =0;
extern int CCIperiod = 50;
extern int CCIprice  = 5;

extern double BarLevl = 5;

//0main;1signal
extern string  MA_Method_Price = "SMA0 EMA1 SMMA2 LWMA3||0O,1C 2H3L,4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6||macdLnMode:0main 1sig";
extern string TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";

double buffer1[], buffer2[], buffer3[], buffer4[];




int init()
{
   SetIndexStyle(0,DRAW_HISTOGRAM);    SetIndexBuffer(0,buffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);    SetIndexBuffer(1,buffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);    SetIndexBuffer(2,buffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM);    SetIndexBuffer(3,buffer4);
   
   
   TimeFrame=MathMax(TimeFrame,Period());  
   
   string name1= " macd: "+macdMAfast+","+macdMAslow+","+macdSigMA;
   string name2= " cci: " +CCIperiod;

   IndicatorShortName("MACDCCI"+name1+name2+" "+TimeFrame);  

   
   return(0);
}



int start()
{
   int i,limit;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;
         if(TimeFrame!=Period())
         limit = MathMax(limit,TimeFrame/Period());

         double max = WindowPriceMax()*3.0;   
   for (i=limit; i>= 0; i--)
   {
              int y =iBarShift(NULL,TimeFrame,Time[i]);
                  
      double  macd0 =iMACD(NULL,TimeFrame,macdMAfast,macdMAslow,macdSigMA,macdPrice,macdLnMode,y);
      double  macd1 =iMACD(NULL,TimeFrame,macdMAfast,macdMAslow,macdSigMA,macdPrice,macdLnMode,y+1);

      double  cci   =iCCI (NULL,TimeFrame,CCIperiod,CCIprice,y);
                
                
                         
      buffer1[i]=0;    buffer2[i]=0;      buffer3[i]=0; buffer4[i]=0;    
      
      if (cci > 0 && macd0 > macd1 )   buffer1[i] = max;  
      else 
      if (cci < 0 && macd0 < macd1 )   buffer2[i] = max;  
      else                             buffer3[i] = max;
   
   }
   return(0);
}

